package de.juplo.jackson;

import com.fasterxml.jackson.core.JsonFactory;
import com.fasterxml.jackson.core.JsonParser;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Spliterator;
import static org.junit.Assert.assertNull;
import org.junit.Test;


/**
 *
 * @author Kai Moritz
 */
public class SimpleMapperTest
{
  private final JsonFactory factory = new JsonFactory();


  @Test
  public void testConvertEmptyInputToArraySpliterator() throws Exception
  {
    Spliterator<Object> spliterator;

    spliterator = SimpleMapper.getArraySpliterator(get("/empty/1.json"));
    assertNull(spliterator);
    spliterator = SimpleMapper.getArraySpliterator(get("/empty/2.json"));
    assertNull(spliterator);
    spliterator = SimpleMapper.getArraySpliterator(get("/empty/3.json"));
    assertNull(spliterator);
    spliterator = SimpleMapper.getArraySpliterator(get("/empty/4.json"));
    assertNull(spliterator);
    spliterator = SimpleMapper.getArraySpliterator(get("/empty/5.json"));
    assertNull(spliterator);
  }

  @Test
  public void testConvertEmptyInputToList() throws Exception
  {
    List<Object> list;

    list = SimpleMapper.convertArray(get("/empty/1.json"));
    assertNull(list);
    list = SimpleMapper.convertArray(get("/empty/2.json"));
    assertNull(list);
    list = SimpleMapper.convertArray(get("/empty/3.json"));
    assertNull(list);
    list = SimpleMapper.convertArray(get("/empty/4.json"));
    assertNull(list);
    list = SimpleMapper.convertArray(get("/empty/5.json"));
    assertNull(list);
  }

  @Test
  public void testConvertEmptyInputToObjectSpliterator() throws Exception
  {
    Spliterator<Entry<String, Object>> spliterator;

    spliterator = SimpleMapper.getObjectSpliterator(get("/empty/1.json"));
    assertNull(spliterator);
    spliterator = SimpleMapper.getObjectSpliterator(get("/empty/2.json"));
    assertNull(spliterator);
    spliterator = SimpleMapper.getObjectSpliterator(get("/empty/3.json"));
    assertNull(spliterator);
    spliterator = SimpleMapper.getObjectSpliterator(get("/empty/4.json"));
    assertNull(spliterator);
    spliterator = SimpleMapper.getObjectSpliterator(get("/empty/5.json"));
    assertNull(spliterator);
  }

  @Test
  public void testConvertEmptyInputToMap() throws Exception
  {
    Map<String, Object> map;

    map = SimpleMapper.convertObject(get("/empty/1.json"));
    assertNull(map);
    map = SimpleMapper.convertObject(get("/empty/2.json"));
    assertNull(map);
    map = SimpleMapper.convertObject(get("/empty/3.json"));
    assertNull(map);
    map = SimpleMapper.convertObject(get("/empty/4.json"));
    assertNull(map);
    map = SimpleMapper.convertObject(get("/empty/5.json"));
    assertNull(map);
  }

  @Test
  public void testConvertEmptyInput() throws Exception
  {
    Object object;

    object = SimpleMapper.convert(get("/empty/1.json"));
    assertNull(object);
    object = SimpleMapper.convert(get("/empty/2.json"));
    assertNull(object);
    object = SimpleMapper.convert(get("/empty/3.json"));
    assertNull(object);
    object = SimpleMapper.convert(get("/empty/4.json"));
    assertNull(object);
    object = SimpleMapper.convert(get("/empty/5.json"));
    assertNull(object);
  }


  private JsonParser get(String resource) throws IOException
  {
    InputStream is = SimpleMapperTest.class.getResourceAsStream(resource);
    return factory.createParser(is);
  }
}
